package cz.zcu.ups.arcaoftpd.users;

import java.io.File;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

/**
 * Trida zastresujici informace o uzivatelych
 * @author Arcao
 */
public class Users {
	private HashMap<String,User> users;

	/**
	 * Konstruktor tridy
	 * @param filename		xml soubor s infomacemi o uzivatelich
	 */
	public Users(String filename) {
		users = new HashMap<String,User>();
		try {
			Document doc;
			//vytvorime instanci nove tovarny
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			factory.setValidating(false);

			//vytvorime noveho stavitele XML dokumentu
			DocumentBuilder builder = factory.newDocumentBuilder();
			//nastaveni hadleru pro vypis chyb
			//builder.setErrorHandler(new ParserErrorHandler());
			//provedeme parsovani XML dokumentu
			doc = builder.parse(new InputSource(new File(filename).toURI().toURL().toString()));

			Element el = (Element) doc.getElementsByTagName("users").item(0);
			NodeList usersNodes = el.getElementsByTagName("user");
			//projedeme vsechny uzivatele
			for(int i=0; i < usersNodes.getLength(); i++) {
				Element user = (Element) usersNodes.item(i);

				//nacteme informace
				String username = user.getAttribute("name");
				String password = user.getElementsByTagName("password").item(0).getNodeValue();
				boolean passwordReq = true;
				if (((Element) user.getElementsByTagName("password").item(0)).hasAttribute("req")) {
					passwordReq = Boolean.parseBoolean(((Element) user.getElementsByTagName("password").item(0)).getAttribute("req"));
				}
				NodeList mapNodes = ((Element) user.getElementsByTagName("maps").item(0)).getElementsByTagName("map");
				Map[] maps = new Map[mapNodes.getLength()];
				//projdeme vsechny namapovane cesty uzivatele
				for(int y=0; y < mapNodes.getLength(); y++) {
					Element mapNode = (Element) mapNodes.item(y);
					maps[y] = new Map(mapNode.getAttribute("source"), mapNode.getAttribute("destination"), mapNode.getAttribute("access"));
				}
				//pridame uzivatele do HashMapy
				users.put(username, new User(username, password, passwordReq, maps));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Vrati informace o zadanem uzivateli
	 * @param username		uzivatelske jmeno
	 * @return				infrormace o uzivateli
	 */
	public User getUser(String username) {
		if (users.containsKey(username)) return users.get(username);
		return null;
	}

	/**
	 * Vraci HashMapu uzivatelu
	 * @return				HashMapa uzivatelu
	 */
	public HashMap<String,User> getUsers() {
		return users;
	}
}
